#!/bin/sh
#NOTE! In case of modification this script MUST be checked to work on unit!

# Any subsequent commands that fail will in most cases cause the script to exit immediately
set -e

if [ "$#" -ne 1 ]
then
	echo "Wrong arguments"
	exit 1
fi
	
TGZ_FILE=$1
FILES_LIST="$(tar -ztf "$TGZ_FILE")" 

if [ "$(echo "$FILES_LIST" | grep -E '^opt/mm/navigationData/rinex/$')" != '' ]
then
	echo Deleting default ephemeris data
	rm -rf /opt/mm/navigationData/rinex
fi

if [ "$(echo "$FILES_LIST" | grep -E '^opt/mm/navigationData/agl/$')" != '' ]
then
	echo Deleting default almanac data
        rm -rf /opt/mm/navigationData/agl
fi
                
echo "Extracting firmware..."
tar -zxf "$TGZ_FILE" -C /

echo "Changing files owner & permissions..."
set +e
cd /
echo "$FILES_LIST" | xargs chown root:root
cd - > /dev/null
set -e

# Сheck FILE exists and has a size greater than zero
if [ -e "/boot/uImage" ]
then
	echo "Flushing kernel...."
	flash_eraseall /dev/mtd2
	nandwrite -p /dev/mtd2 /boot/uImage
	rm -rf /boot
fi

set +e
echo "Removing unwanted files..."
sh /bin/remove_unwanted_files.sh 2> /dev/null
set -e

echo "Removing update file"
rm -f "$TGZ_FILE"

echo "DONE"

exit 0


