window.onload = function( ) {

    setInterval(function() {
        updateDisplay();
    }, 500);
};

// event.type should be keypress
function getChar(event) {
    if (typeof event.which === 'undefined') { // IE
       if (event.keyCode < 32) return null; // special char
       return String.fromCharCode(event.keyCode);
    };

    if (event.which != 0 && event.charCode != 0) { // all except IE
        if (event.which < 32) return null; // special char
        return String.fromCharCode(event.which);
    };

    return null;
};

function makeShiftedCodeString(charCode) {
    return '$'+(charCode+128).toString();
};

function processKeypress(e, stringCode) {
    e.preventDefault();
    sendButton(stringCode);
};

function updateDisplay() {
    document.images["screen"].src = "dump.bmp?rand="+ Math.random();
};

function sendButton(stringCode) {
    var url = "/cgi-bin/asw_command_cgi?cmd=" + stringCode;
    var xmlhttp;
    if (window.XMLHttpRequest)
    { // code for IE7+, Firefox, Chrome, Opera, Safari
        xmlhttp=new XMLHttpRequest();
    }
    else
    {// code for IE6, IE5
     xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
    }
    xmlhttp.open("GET", url, true);
    xmlhttp.send();
};

document.onkeypress = function(e) {
    var ch = getChar(e);
    var chCode = null;
    if (ch != null)
        chCode = ch.charCodeAt(0);

    if (e.ctrlKey && ch=='s') processKeypress(e, 's'); // START
    if (e.ctrlKey && ch=='m') processKeypress(e, 'V'); // MENU
    if (e.ctrlKey && ch=='e') processKeypress(e, 'e'); // EW
    if (e.ctrlKey && ch=='n') processKeypress(e, 'n'); // NS

    if (ch=='.') processKeypress(e, '.'); // COMMA
    if (ch=='=') processKeypress(e, '-'); // PLUSMINUS

    if (ch>='0' && ch<='9') processKeypress(e, ch);

    if (ch>='a' && ch<='z') processKeypress(e, makeShiftedCodeString(chCode));
    if (ch>='A' && ch<='Z') processKeypress(e, makeShiftedCodeString(chCode));

    if (ch=='-') processKeypress(e, makeShiftedCodeString(chCode));
    if (ch=='_') processKeypress(e, makeShiftedCodeString(chCode));
};

document.onkeydown = function(e) {
    if (e.keyCode==13) processKeypress(e, "enter");  // ENTER

    if (e.keyCode==8)  processKeypress(e, 'x'); // EXIT
    if (e.keyCode==27) processKeypress(e, 'c'); // CANCEL
    if (e.keyCode==34) processKeypress(e, 'p'); // VIEW

    if (e.keyCode==37) processKeypress(e, 'j'); // LEFT
    if (e.keyCode==38) processKeypress(e, 'i'); // UP
    if (e.keyCode==39) processKeypress(e, 'k'); // RIGHT
    if (e.keyCode==40) processKeypress(e, 'm'); // DOWN

    if (e.keyCode==46) processKeypress(e, 'D'); // DELETE
};
